/******************************************************************************
 *  CVS version:
 *     $Id: error.c,v 1.1 2003/05/13 22:21:01 nickie Exp $
 *	
 *	24/8/2003 12:06
 ******************************************************************************
 *
 *  C code file : error.c
 *  Project     : PCL Compiler
 *  Version     : 1.0 alpha
 *  Written by  : Nikolaos S. Papaspyrou (nickie@softlab.ntua.gr)
 *  Date        : May 14, 2003
 *  Description : Generic symbol table in C, simple error handler
 *
 *  Comments: (in Greek iso-8859-7)
 *  ---------
 *    .
 *       .
 *      .
 *    
 */
 /*
	H  error(..)    ,  
	    ...
 */

/* ---------------------------------------------------------------------
   ---------------------------- Header files ---------------------------
   --------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdbool.h>
#include "error.h"

/* ---------------------------------------------------------------------
   ---------       ----------
   --------------------------------------------------------------------- */

void internal (const char * fmt, ...)
{
    va_list ap;
    
    va_start(ap, fmt);
    fprintf(stderr, "Internal error: ");
    vfprintf(stderr, fmt, ap);
    fprintf(stderr, "\n");
    va_end(ap);
    exit(1);
}

void fatal (const char * fmt, ...)
{
    va_list ap;
    
    va_start(ap, fmt);
    fprintf(stderr, "Fatal error: ");
    vfprintf(stderr, fmt, ap);
    fprintf(stderr, "\n");
    va_end(ap);
    exit(1);
}

void error (const char * fmt, ...)
{
    va_list ap;
    
    va_start(ap, fmt);
    if(depth)
    	fprintf(stderr, "%s:%d, Error:  ", include_name, line_count);
    else 
    	fprintf(stderr, "%s:%d, Error:  ", f_name, line_count);
    vfprintf(stderr, fmt, ap);
    fprintf(stderr, "\n");
    va_end(ap);
    found_error = true;
  /*  yyclearin();
    while(strcmp(yytext,";"))
    {
    	printf("%s\n", yytext);
    	yylex();
    
    }*/
  //  ScopeQuads2file(fp_quad, &head3);
  //  ScopeQuads2asm(fp_asm, &head2);
    exit(1);   
}

void warning (const char * fmt, ...)
{
    va_list ap;
    
    va_start(ap, fmt);
    fprintf(stderr, "Warning: ");
    vfprintf(stderr, fmt, ap);
    fprintf(stderr, "\n");
    va_end(ap);
    exit(1);
}
