/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 *    	mpapakyr@softlab.ece.ntua.gr   *
 *   							       *
 *    		tsokos@softlab.ece.ntua.gr     *
 *  							       *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  		   		       *
 *  		   	       *
 *  							       *
 *  	: `   Calvin`	       *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 							       *
 *  File Name: 		quad2asm.c			       *
 *  Version: 		1.0 Final			       *
 *  Description:        Quad generation C source code          *
 *			and Quad to .ASM Intel 8086 assembly   *
 * 			file  				       *		
 *  Date:    		23/10/2003 1:10		       *
 *  							       *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>


#include "symbol.c"
#include "error.c"
#include "quad2asm.h"





int genquad(int label, Quad_Type quad, b op1, c op2, d op3, bool size)
{
	Quad_list *tmp;
	tmp = (Quad_list *)malloc(sizeof(Quad_list));
	tmp->list_next = NULL;
	if(head2 == NULL) {
		head2 = tmp;
		bottom2 = tmp;
		tmp->next = NULL;
		tmp->prior = NULL;
		head3 = head2;
	}
	else {
		bottom2->next = tmp;
		tmp->prior = bottom2;
		bottom2 = tmp;
		bottom2->next = NULL;
	}	
	if((quad>4)&&(quad<11)) { 
		bottom2->type = quad;
		bottom2->label = label;
		bottom2->sec.q_union.x = op1.q_union.x;
		bottom2->third.q_union.x = op2.q_union.x;
		bottom2->fourth.q_union.label = op3.q_union.label;
		bottom2->sec.code = op1.code ;  
		bottom2->third.code = op2.code;
		bottom2->size = size;
	}	
	else if(quad<5)
	{
		bottom2->type = quad;
		bottom2->label = label;
		bottom2->sec.q_union.x = op1.q_union.x;
		bottom2->third.q_union.x = op2.q_union.x;
		bottom2->fourth.q_union.x = op3.q_union.x;
		bottom2->sec.code = op1.code ;  
		bottom2->third.code = op2.code;
		bottom2->fourth.code = op3.code;
	}	
	else switch(quad) {
		case UNIT_QUAD: 		
		case ENDU_QUAD: 
				bottom2->type = quad;
				bottom2->label = label;				
				bottom2->sec.q_union.x = op1.q_union.x;								
				break;
		case ASSIGN_QUAD:
				bottom2->type = quad;
				bottom2->label = label;
				bottom2->sec.q_union.x = op1.q_union.x;
				bottom2->fourth.q_union.x = op3.q_union.x;
				bottom2->sec.code = op1.code ;  
				bottom2->size = size;
				bottom2->third.code = op2.code;
				break;
		/*case ARRAY_QUAD:
				bottom2->type = quad;
				bottom2->label = label;
				bottom2->sec.q_union.x = op1.q_union.x;
				bottom2->third.q_union.index = op2.q_union.index;
				bottom2->fourth.q_union.x = op3.q_union.x;
				break;*/
		case IFB_QUAD:  
				bottom2->type = quad;
				bottom2->label = label;
				bottom2->sec.q_union.x = op1.q_union.x;
				bottom2->fourth.q_union.label = op3.q_union.label; 
				break;
		case CALL_QUAD: 
				bottom2->fourth.q_union.x = op3.q_union.x;
				bottom2->type = quad;
				bottom2->label = label;
				break;
		case RET_QUAD:  			
				bottom2->type = quad;	
				bottom2->label = label;
				break;
		case PAR_QUAD: 
				bottom2->sec.q_union.x = op1.q_union.x;
				bottom2->type = quad;
				bottom2->label = label;
				bottom2->third.q_union.pass = op2.q_union.pass;
				bottom2->sec.code = op1.code ; 
				bottom2->fourth.code = op3.code; 
				bottom2->fourth.q_union.x = op3.q_union.x;
				bottom2->size = size;
				break;
		case JMP_QUAD:  
				bottom2->fourth.q_union.label = op3.q_union.label;	
				bottom2->type = quad;
				bottom2->label = label;
				break;		
		case ARR2T_QUAD:
		case T2ARR_QUAD:
				bottom2->label = label;
				bottom2->type = quad;
				bottom2->size = size;
				bottom2->sec.q_union.x = op1.q_union.x;
				bottom2->sec.code = op1.code;
				bottom2->third.q_union.x = op2.q_union.x;
				bottom2->third.code = op2.code;
				bottom2->fourth.q_union.x = op3.q_union.x;
				break; 
				
		}		
}

void printquad(FILE *fp, Quad_list *a)
{	
	if(a == NULL) fprintf(fp, "ERROR !!!!!");
	else while(a != NULL)
	{
		print_one_quad(fp, a);
		a = a->next;
	}	
}


int print_one_quad(FILE *fp, Quad_list *a)
{	
	if(a == NULL)
		fprintf(fp, "Empty quad.\n");
	else if((a->type>4)&&(a->type<11)) { 
		if(a->sec.code == true && a->third.code == true)
			fprintf(fp, "%d: %s, %d, %d, %d\n", a->label, quad_tag[a->type], (int)a->sec.q_union.x, (int)a->third.q_union.x, a->fourth.q_union.label);
		else if(a->sec.code == false && a->third.code == true)	
			fprintf(fp, "%d: %s, %s, %d, %d\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, (int)a->third.q_union.x, a->fourth.q_union.label);
		else if(a->sec.code == true && a->third.code == false)	
			fprintf(fp, "%d: %s, %d, %s, %d\n", a->label, quad_tag[a->type], (int)a->sec.q_union.x, a->third.q_union.x->id, a->fourth.q_union.label);
		else if(a->sec.code == false && a->third.code == false)	
			fprintf(fp, "%d: %s, %s, %s, %d\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, a->third.q_union.x->id, a->fourth.q_union.label);	
	}		
	else if(a->type<5) {
		if(a->sec.code == true && a->third.code == true)
			fprintf(fp, "%d: %s, %d, %d, %s\n", a->label, quad_tag[a->type], (int)a->sec.q_union.x, (int)a->third.q_union.x, a->fourth.q_union.x->id);
		else if(a->sec.code == false && a->third.code == true)	
			fprintf(fp, "%d: %s, %s, %d, %s\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, (int)a->third.q_union.x, a->fourth.q_union.x->id);
		else if(a->sec.code == true && a->third.code == false)	
			fprintf(fp, "%d: %s, %d, %s, %s\n", a->label, quad_tag[a->type], (int)a->sec.q_union.x, a->third.q_union.x->id, a->fourth.q_union.x->id);
		else if(a->sec.code == false && a->third.code == false)	
			fprintf(fp, "%d: %s, %s, %s, %s\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, a->third.q_union.x->id, a->fourth.q_union.x->id);		
	}	
	else switch(a->type) {
		case UNIT_QUAD: 		
		case ENDU_QUAD: 
				fprintf(fp, "%d: %s, %s, -, -\n", a->label, quad_tag[a->type], a->sec.q_union.x->id);			
				break;
		case ARR2T_QUAD:
		case T2ARR_QUAD:
				if(a->third.code && a->sec.code)
					fprintf(fp, "%d: %s, %d, %d, %s\n", a->label, quad_tag[a->type], a->sec.q_union.x, a->third.q_union.x , a->fourth.q_union.x->id);				
				else if(!a->third.code && !a->sec.code)
					fprintf(fp, "%d: %s, %s, %s, %s\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, a->third.q_union.x->id , a->fourth.q_union.x->id);
				else if(a->third.code && !a->sec.code)
					fprintf(fp, "%d: %s, %s, %d, %s\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, a->third.q_union.x , a->fourth.q_union.x->id);
				else if(!a->third.code && a->sec.code)
					fprintf(fp, "%d: %s, %d, %s, %s\n", a->label, quad_tag[a->type], a->sec.q_union.x, a->third.q_union.x->id , a->fourth.q_union.x->id);
				break;
		case ASSIGN_QUAD:
					if(a->sec.code)
						fprintf(fp, "%d: %s, %d, -, %s\n", a->label, quad_tag[a->type], (int)a->sec.q_union.x, a->third.code ? "$$":a->fourth.q_union.x->id);
					else if(!a->sec.code)	
						fprintf(fp, "%d: %s, %s, -, %s\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, a->third.code ? "$$":a->fourth.q_union.x->id);
				break;
		/*case ARRAY_QUAD:
				fprintf(fp, "%d: %s, %s, %d, xxx\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, a->third.q_union.index); 
				break;		*/
		case IFB_QUAD:  
				fprintf(fp, "%d: %s, %s, -, %d\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, a->fourth.q_union.label);			 
				break;
		case CALL_QUAD: 
				fprintf(fp, "%d: %s, -, -, %s\n", a->label, quad_tag[a->type], a->fourth.q_union.x->id);
				break;
		case RET_QUAD:  	
				fprintf(fp, "%d: %s, -, -, -\n", a->label, quad_tag[a->type]);			
				break;
		case PAR_QUAD: 
				if(a->fourth.code == true) {
					fprintf(fp, "%d: %s, %s, %s, -\n", a->label, quad_tag[a->type], a->sec.q_union.name, pass_tag[a->third.q_union.pass]);
					;
				}
				else if(a->third.q_union.pass == RET)
					fprintf(fp, "%d: %s, %s, %s, -\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, pass_tag[a->third.q_union.pass]);
				else if(a->fourth.q_union.x != NULL)
					fprintf(fp, "%d: %s, %s[%s], %s, -\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, a->fourth.q_union.x->id, pass_tag[a->third.q_union.pass]);
				else {
					if(a->sec.code == true)
					{
						fprintf(fp, "%d: %s, %d, %s, -\n", a->label, quad_tag[a->type], (int)a->sec.q_union.x, pass_tag[a->third.q_union.pass]);
					}
					else if(a->sec.code == false)	
						fprintf(fp, "%d: %s, %s, %s, -\n", a->label, quad_tag[a->type], a->sec.q_union.x->id, pass_tag[a->third.q_union.pass]);				
				}
				break;
		case JMP_QUAD:  
				fprintf(fp, "%d: %s, -, -, %d\n", a->label, quad_tag[a->type], a->fourth.q_union.label);	
				break;		
		default : break;
		}
}
void init_tags()
{
	pass_tag[0]=(char *)malloc(sizeof(char));
	strcpy(pass_tag[0], "V");
	pass_tag[1]=(char *)malloc(sizeof(char));
	strcpy(pass_tag[1], "R");
	pass_tag[2]=(char *)malloc(3*sizeof(char));
	strcpy(pass_tag[2], "RET");
		
	quad_tag[0]=(char *)malloc(sizeof(char));
	strcpy(quad_tag[0], "+");
	quad_tag[1]=(char *)malloc(sizeof(char));
	strcpy(quad_tag[1], "-");
	quad_tag[2]=(char *)malloc(sizeof(char));
	strcpy(quad_tag[2], "*");
	quad_tag[3]=(char *)malloc(sizeof(char));
	strcpy(quad_tag[3], "/");	
	quad_tag[4]=(char *)malloc(sizeof(char));
	strcpy(quad_tag[4], "%");
	quad_tag[5]=(char *)malloc(2*sizeof(char));
	strcpy(quad_tag[5], "==");
	quad_tag[6]=(char *)malloc(2*sizeof(char));
	strcpy(quad_tag[6], "!=");
	quad_tag[7]=(char *)malloc(sizeof(char));
	strcpy(quad_tag[7], ">");	
	quad_tag[8]=(char *)malloc(2*sizeof(char));
	strcpy(quad_tag[8], ">=");
	quad_tag[9]=(char *)malloc(sizeof(char));
	strcpy(quad_tag[9], "<");
	quad_tag[10]=(char *)malloc(2*sizeof(char));
	strcpy(quad_tag[10], "<=");
	quad_tag[11]=(char *)malloc(2*sizeof(char));
	strcpy(quad_tag[11], ":=");	
	quad_tag[12]=(char *)malloc(4*sizeof(char));
	strcpy(quad_tag[12], "call");
	quad_tag[13]=(char *)malloc(3*sizeof(char));
	strcpy(quad_tag[13], "par");
	quad_tag[14]=(char *)malloc(4*sizeof(char));
	strcpy(quad_tag[14], "jump");
	quad_tag[15]=(char *)malloc(3*sizeof(char));
	strcpy(quad_tag[15], "ret");	
	quad_tag[16]=(char *)malloc(4*sizeof(char));
	strcpy(quad_tag[16], "unit");
	quad_tag[17]=(char *)malloc(4*sizeof(char));
	strcpy(quad_tag[17], "endu");
	quad_tag[18]=(char *)malloc(5*sizeof(char));
	strcpy(quad_tag[18], "array");
	quad_tag[19]=(char *)malloc(4*sizeof(char));
	strcpy(quad_tag[19], "retv");	
	quad_tag[20]=(char *)malloc(3*sizeof(char));
	strcpy(quad_tag[20], "ifb");
	quad_tag[21]=(char *)malloc(4*sizeof(char));
	strcpy(quad_tag[21], ":=[]");
	quad_tag[22]=(char *)malloc(4*sizeof(char));
	strcpy(quad_tag[22], "[]:=");
}

		
FILE * init_file(char *name)
{
	FILE *fp;
	fp=fopen(name,"w");
	if(fp==NULL) error("Cannot create file \"a.asm\" . Disk may have run out of space");
	else return fp;
}

void getAR(FILE *fp, SymbolEntry *a)
{
	int n;
	if(! (currentScope->nestingLevel > a->nestingLevel)) fprintf(fp, ";Error: wrong nesting level.\n");
	n = currentScope->nestingLevel - a->nestingLevel - 1;
	fprintf(fp, "\tmov si,word ptr [bp+4]\n");
	while(n >= 1)
	{
		fprintf(fp, "\tmov si,word ptr [si+4]\n");
		n--;
	}
}

void updateAL(FILE *fp, SymbolEntry *a)
{
	
	int np, nx;
	np = currentScope->nestingLevel;
	nx = a->nestingLevel;
	nx++;	
	if(np < nx || nx == 0) fprintf(fp, "\tpush bp\n");
	else if(np == nx) fprintf(fp, "\tpush word ptr [bp+4]\n");
	else //np > nx
	{
		fprintf(fp, "\tmov si,word ptr [bp+4]\n");
		np = np-nx-1;
		while(np > 1)
		{
			fprintf(fp, "\tmov si,word ptr [si+4]\n");
			np--;
		}
		fprintf(fp, "\tpush word ptr [si+4]\n");
	}
}

	
void load(FILE *fp, char a[2], SymbolEntry *b, bool code, int index)
{
	int n;
	if(code == true)
	{
		fprintf(fp, "\tmov %s,%d\n", a, (int)b);
	}
	else if(currentScope->nestingLevel == b->nestingLevel)
	{
		switch(b->entryType)
		{
			case ENTRY_VARIABLE:
				n = b->u.eVariable.offset;
				break;
			case ENTRY_PARAMETER:
				n = b->u.eParameter.offset;
				break;
			case ENTRY_TEMPORARY:
				n = b->u.eTemporary.offset;
				break;
		}
		if(b->entryType == ENTRY_PARAMETER && b->u.eParameter.mode == PASS_BY_REFERENCE)
		{
			fprintf(fp, "\tmov si,word ptr [bp+%d]\n", n);
			fprintf(fp, "\tmov %s, %s ptr [si]\n", a, a[1] == 'l' ? "byte":"word");
		}
		else if(b->entryType == ENTRY_PARAMETER)
			fprintf(fp, "\tmov %s,%s ptr [bp+%d]\n", a, a[1] == 'l' ? "byte":"word", n);
		else
			fprintf(fp, "\tmov %s,%s ptr [bp%d]\n", a, a[1] == 'l' ? "byte":"word", n);
	}
	else // if(currentScope->nestingLevel != b->nestingLevel)
	{
		getAR(fp, b);
		switch(b->entryType)
		{
			case ENTRY_VARIABLE:
				n = b->u.eVariable.offset;
				break;
			case ENTRY_PARAMETER:
				n = b->u.eParameter.offset;
				break;
			case ENTRY_TEMPORARY:
				n = b->u.eTemporary.offset;
				break;
		}
		if(b->entryType == ENTRY_PARAMETER && b->u.eParameter.mode == PASS_BY_REFERENCE)
		{
			fprintf(fp, "\tmov si,word ptr [si+%d]\n", n);
			fprintf(fp, "\tmov %s, %s ptr [si]\n", a, a[1] == 'l' ? "byte":"word");
		}
		else if(b->entryType == ENTRY_PARAMETER)
			fprintf(fp, "\tmov %s,%s ptr [si+%d]\n", a, a[1] == 'l' ? "byte":"word", n);
		else
			fprintf(fp, "\tmov %s,%s ptr [si%d]\n", a, a[1] == 'l' ? "byte":"word", n);
	}		
		
}

void loadAddr(FILE *fp, char a[2], SymbolEntry *b, int index)
{
	char c[3],d[2];int n;
	if(b->entryType == ENTRY_CONSTANT && b->u.eConstant.type == typeChar )
	{
		fprintf(fp, "\tlea %s,byte ptr %s\n", a, b->u.eConstant.value.vString);
		return;
	}
	else if(index != 0)
	{
		loadAddr(fp, a, b, 0);
		load(fp, "di", index, true, 0);
		fprintf(fp, "\tadd %s,di\n", a); //mult size
	}
	else if(currentScope->nestingLevel == b->nestingLevel)
	{
		if(b->entryType == ENTRY_VARIABLE && b->u.eVariable.type->kind == TYPE_ARRAY)
			fprintf(fp, "\tlea %s,%s ptr [bp%d]\n", a, a[1]=='l' ? "byte":"word", b->u.eVariable.offset);
		else if( (b->entryType == ENTRY_PARAMETER) && (b->u.eParameter.mode == PASS_BY_REFERENCE || b->u.eParameter.type->kind == TYPE_IARRAY) )
			fprintf(fp, "\tmov %s,word ptr [bp+%d]\n", a, b->u.eParameter.offset );
		else if(b->entryType == ENTRY_PARAMETER && b->u.eParameter.mode == PASS_BY_VALUE)
			fprintf(fp, "\tlea %s,%s ptr [bp+%d]\n", a, a[1]=='l' ? "byte":"word", b->u.eParameter.offset );
		else //if(b->entryType == ENTRY_TEMPORARY)
			fprintf(fp, "\tlea %s,%s ptr [bp%d]\n", a, a[1]=='l' ? "byte":"word", b->u.eTemporary.offset );
	}
	else //if(currentScope->nestingLevel != b->nestingLevel)
	{
		if(b->entryType == ENTRY_VARIABLE && b->u.eVariable.type->kind == TYPE_ARRAY)
		{
			getAR(fp, b);
			fprintf(fp, "\tlea %s,%s ptr [si%c%d]\n", a, a[1]=='l' ? "byte":"word", b->u.eVariable.offset == 0 ? '-':' ', b->u.eVariable.offset);
		}
		else if( (b->entryType == ENTRY_PARAMETER) && ( b->u.eParameter.mode == PASS_BY_REFERENCE || b->u.eParameter.type->kind == TYPE_IARRAY) )
		{
			getAR(fp, b);
			fprintf(fp, "\tmov %s,word ptr [si+%d]\n", a, b->u.eParameter.offset );
		}
		else if(b->entryType == ENTRY_PARAMETER && b->u.eParameter.mode == PASS_BY_VALUE)
		{
			getAR(fp, b);
			fprintf(fp, "\tlea %s,%s ptr [si+%d]\n", a, a[1]=='l' ? "byte":"word", b->u.eParameter.offset );
		}
		else //if(b->entryType == ENTRY_TEMPORARY)
		{
			getAR(fp, b);
			fprintf(fp, "\tlea %s,%s ptr [si%d]\n", a, a[1]=='l' ? "byte":"word", b->u.eTemporary.offset );
		}
	}
}


void store(FILE *fp, char a[2], SymbolEntry *b, SymbolEntry *index)
{
	if(index != NULL)
	{
		loadAddr(fp, "si", b, 0);
		load(fp, "di", index, false, 0);
		fprintf(fp, "\tadd si,di\n"); 
		if(a[1] == 'x') fprintf(fp, "\tadd si,di\n"); // mult size
		fprintf(fp, "\tmov %s ptr [si],%s\n", a[1]=='l' ? "byte":"word", a);
	}
	else if(currentScope->nestingLevel == b->nestingLevel)
	{
		if(b->entryType == ENTRY_PARAMETER && b->u.eParameter.mode == PASS_BY_VALUE)
			fprintf(fp, "\tmov %s ptr [bp+%d],%s\n", a[1]=='l' ? "byte":"word", b->u.eParameter.offset, a);
		else if(b->entryType == ENTRY_PARAMETER && b->u.eParameter.mode == PASS_BY_REFERENCE)
		{
			fprintf(fp, "\tmov si,word ptr [bp+%d]\n", b->u.eParameter.offset);
			fprintf(fp, "\tmov %s ptr [si],%s\n", a[1]=='l' ? "byte":"word", a);
		}
		else if(b->entryType == ENTRY_TEMPORARY)
			fprintf(fp, "\tmov %s ptr [bp%d],%s\n", a[1]=='l' ? "byte":"word", b->u.eTemporary.offset, a);	
		else if(b->entryType == ENTRY_VARIABLE)
			fprintf(fp, "\tmov %s ptr [bp%d],%s\n", a[1]=='l' ? "byte":"word", b->u.eVariable.offset, a);		
	}
	else // if(currentScope->nestingLevel != b->nestingLevel)
	{
		getAR(fp, b);
		if(b->entryType == ENTRY_PARAMETER && b->u.eParameter.mode == PASS_BY_VALUE)
			fprintf(fp, "\tmov %s ptr [si+%d],%s\n", a[1]=='l' ? "byte":"word", b->u.eParameter.offset, a);
		else if(b->entryType == ENTRY_PARAMETER && b->u.eParameter.mode == PASS_BY_REFERENCE)
		{
			fprintf(fp, "\tmov si,word ptr [si+%d]\n", b->u.eParameter.offset);
			fprintf(fp, "\tmov %s ptr [si],%s\n", a[1]=='l' ? "byte":"word", a);
		}
		else if(b->entryType == ENTRY_TEMPORARY)
			fprintf(fp, "\tmov %s ptr [si%d],%s\n", a[1]=='l' ? "byte":"word", b->u.eTemporary.offset, a);
		else if(b->entryType == ENTRY_VARIABLE)
			fprintf(fp, "\tmov %s ptr [si%d],%s\n", a[1]=='l' ? "byte":"word", b->u.eVariable.offset, a);	
	}		
}


void label(FILE *fp, int x, int i)
{
	if(i == 1) fprintf(fp, "@%d",x);
	else if(i == 4) fprintf(fp, "@%d_5:\n", x - 1);
	else if(i == 5) fprintf(fp, "@%d_5\n", x - 1);
	else fprintf(fp, "@%d:\n",x);
}

void endof(FILE *fp, SymbolEntry *b, int i)
{
	if(i == 4) ///main func
		fprintf(fp, "@_%s_1:\n", b->id);
	else if(i == 0)
		fprintf(fp, "@_%s_%d:\n", b->id, find_FuncList(b->id));
	else if(i == 1)
		fprintf(fp, "%s\n", endof_str);
}

void name(FILE *fp, SymbolEntry *b, int i)
{
	if(i ==  1) 
	/*   */
		if(b->u.eFunction.is2)
			fprintf(fp, "_%s_%d", b->id, find_FuncList(b->id) );
		else
			fprintf(fp, "_%s_%d", b->id, find_FuncList(b->id) );
	/*	*/
	else if(i == 0)
	{
		endof_str = (char *)malloc(strlen(b->id)+strlen(myitoa(find_FuncList(b->id), NULL, 1))+1);
		sprintf(endof_str, "@_%s_%d", b->id, find_FuncList(b->id));
		fprintf(fp, "_%s_%d", b->id, find_FuncList(b->id));
	}			
	else if(i == 4) // main func
	{
		endof_str = (char *)malloc(sizeof("@_main_1") + 1);
		sprintf(endof_str, "@_main_1");
		fprintf(fp, "_%s_1", b->id );
	}
	else
		;//exit(1);
}
void call_name(FILE *fp, SymbolEntry *b, int i)
{
	int n = find_FuncList(b->id);
	if(n)
		fprintf(fp, "_%s_%d\n", b->id, n);
	else 
		fprintf(fp, "_%s\n", b->id);
}


void ScopeQuads2asm(FILE *fp, Quad_list **l)
{
	if(first_asm) {
		first_asm = false;
		quad2asm(fp, (*l));
	}
	while((*l)->next != NULL)
	{
		quad2asm(fp, (*l)->next);
		(*l) = (*l)->next; 
	}
}

void printQuadList(FILE *fp, Quad_list *l)
{
	while(l != NULL)
	{
		print_one_quad(fp, l);
		l = l->list_next;
	}
}

void ScopeQuads2file(FILE *fp, Quad_list **l)
{
	if(first_quad) {
		first_quad = false;
		print_one_quad(fp, (*l));
	}
		
	while((*l)->next != NULL)
	{
		print_one_quad(fp, (*l)->next);
		(*l) = (*l)->next;
	}	
	
}
	
	
void all_quads2asm(FILE *fp, Quad_list *l)
{	
	if(!l) fprintf(fp, "ERROR!!!!!!");
	else while(l)
	{
		quad2asm(fp, l);
		l = l->next;
	}
}

		

void quad2asm(FILE *fp, Quad_list *l)
{
	int n;
	char instr[10], a[3], d[3];
	label(fp, counter++, 0);
	if((l->type>4)&&(l->type<11)) { 
		switch(l->type) {
			case EQ_QUAD:strcpy(instr,"je ");break;
			case NE_QUAD:strcpy(instr,"jne ");break;
			case GE_QUAD:strcpy(instr,"jge ");break;
			case LE_QUAD:strcpy(instr,"jle ");break;
			case GT_QUAD:strcpy(instr,"jg ");break;
			case LT_QUAD:strcpy(instr,"jl ");break;
			default://fprintf(fp,"\t");
				break;		
		}
		strcpy(a, l->size ? "ax":"al");
		strcpy(d, l->size ? "dx":"dl");
		
		load(fp, a, l->sec.q_union.x, l->sec.code, 0);
		load(fp, d, l->third.q_union.x, l->third.code, 0);        
		fprintf(fp, "\tcmp %s,%s\n", a, d);
		fprintf(fp, "\t%s", instr);
		label(fp, l->fourth.q_union.label, 1);
		fprintf(fp, "\n");
	}		
	else switch(l->type) {
		case UNIT_QUAD: 				
				if(strcmp(l->sec.q_union.x->id, "main"))
					name(fp ,l->sec.q_union.x, 0);
				else
					name(fp ,l->sec.q_union.x, 4);
				fprintf(fp," proc near\n\tpush bp\n\tmov bp,sp\n\tsub sp,");
				fprintf(fp, "%d\n", -(currentScope->negOffset));
				//push_FuncList(currentScope->nestingLevel, block_counter , l->sec.q_union.x->id);
				break;
		case ENDU_QUAD: if(strcmp(l->sec.q_union.x->id, "main"))
					endof(fp, l->sec.q_union.x, 0);
				else
					endof(fp, l->sec.q_union.x, 4);
				fprintf(fp,"\tmov sp,bp\n\tpop bp\n\tret\n");
				if(strcmp(l->sec.q_union.x->id, "main"))
					name(fp ,l->sec.q_union.x, 1);
				else
					name(fp ,l->sec.q_union.x, 4);
				fprintf(fp," endp\n");
				pop_FuncList(currentScope->nestingLevel + 1);
//original pot			push_FuncList(currentScope->nestingLevel, block_counter - 1, l->sec.q_union.x->id);
				break;
		case ASSIGN_QUAD:
				if(l->third.code) {
					if(l->sec.code)
						fprintf(fp, "\tmov ax,%d\n", l->sec.q_union.x);
					else
						load(fp, l->size ? "ax":"al", l->sec.q_union.x, l->sec.code, 0);
					fprintf(fp, "\tmov si,word ptr [bp+6]\n\tmov word ptr [si],ax\n");
				}
				else {
					if(l->sec.code)
						fprintf(fp, "\tmov ax,%d\n", l->sec.q_union.x);
					else
						load(fp, l->size ? "ax":"al", l->sec.q_union.x, l->sec.code, 0);
					store(fp, l->size ? "ax":"al", l->fourth.q_union.x, NULL);
				}
				break;
		/*case ARRAY_QUAD://load(fp, "ax", l->third.q_union.index)
				fprintf(fp, "\tmov ax,%d\n\t", l->third.q_union.index);
				fprintf(fp,"mov cx,%d\n\t", l->sec.q_union.x->u.eVariable.type->kind == 1 ? 8:16 );
				fprintf(fp,"imul cx\n\t");
				//loadAddr("cx",l->sec.q_union.x);
				fprintf(fp,"add ax,cx\n");
				//store(fp,"ax",l->fourth.q_union.x); */
				break;
		case PLUS_QUAD: 
				if(l->sec.code)
					fprintf(fp, "\tmov ax,%d\n", l->sec.q_union.x);
				else
					load(fp, "ax", l->sec.q_union.x, l->sec.code, 0);
				if(l->third.code)
					fprintf(fp, "\tmov dx,%d\n", l->third.q_union.x);
				else
					load(fp, "dx", l->third.q_union.x, l->third.code, 0);
				fprintf(fp, "\tadd ax,dx\n");
				store(fp, "ax", l->fourth.q_union.x, NULL);
				break;
		case MINUS_QUAD:if(l->sec.code)
					fprintf(fp, "\tmov ax,%d\n", l->sec.q_union.x);
				else
					load(fp, "ax", l->sec.q_union.x, l->sec.code, 0);
				if(l->third.code)
					fprintf(fp, "\tmov dx,%d\n", l->third.q_union.x);
				else
					load(fp, "dx", l->third.q_union.x, l->third.code, 0);
				fprintf(fp, "\tsub ax,dx\n");
				store(fp, "ax", l->fourth.q_union.x, NULL);
				break;
		case MULT_QUAD: if(l->sec.code)
					fprintf(fp, "\tmov ax,%d\n", l->sec.q_union.x);
				else
					load(fp, "ax", l->sec.q_union.x, l->sec.code, 0);
				if(l->third.code)
					fprintf(fp, "\tmov cx,%d\n", l->third.q_union.x);
				else
					load(fp, "cx", l->third.q_union.x, l->third.code, 0);
				fprintf(fp, "\timul cx\n");
				store(fp, "ax", l->fourth.q_union.x, NULL);
				break;
		case DIV_QUAD:  if(l->sec.code)
					fprintf(fp, "\tmov ax,%d\n", l->sec.q_union.x);
				else
					load(fp, "ax", l->sec.q_union.x, l->sec.code, 0);
				fprintf(fp, "\txor dx,dx\n");
				if(l->third.code)
					fprintf(fp, "\tmov cx,%d\n", l->third.q_union.x);
				else
					load(fp, "cx", l->third.q_union.x, l->third.code, 0);
				fprintf(fp, "\tidiv cx\n");
				store(fp, "ax", l->fourth.q_union.x, NULL);
				break;
		case MOD_QUAD: if(l->sec.code)
					fprintf(fp, "\tmov ax,%d\n", l->sec.q_union.x);
				else
					load(fp, "ax", l->sec.q_union.x, l->sec.code, 0);
				fprintf(fp, "\txor dx,dx\n");
				if(l->third.code)
					fprintf(fp, "\tmov cx,%d\n", l->third.q_union.x);
				else
					load(fp, "cx", l->third.q_union.x, l->third.code, 0);
				fprintf(fp, "\tidiv cx\n");
				store(fp, "dx", l->fourth.q_union.x, NULL);
				break;
		case IFB_QUAD:  load(fp, "al", l->sec.q_union.x, l->sec.code, 0);
				fprintf(fp, "\tor al,al\n\tjnz");
				label(fp, l->fourth.q_union.label, 1);
				break;
		case CALL_QUAD: 
				if(l->fourth.q_union.x->u.eFunction.resultType == typeVoid)
					fprintf(fp, "\tsub sp,2\n");
				if( l->fourth.q_union.x->u.eFunction.firstArgument == NULL) n = 4;
				else n = l->fourth.q_union.x->u.eFunction.firstArgument->u.eParameter.offset - 4
					+ sizeOfType(l->fourth.q_union.x->u.eFunction.firstArgument->u.eParameter.type);
				updateAL(fp, l->fourth.q_union.x);
				fprintf(fp, "\tcall near ptr ");
				call_name(fp, l->fourth.q_union.x, 2); //********************
				fprintf(fp, "\tadd sp,%d\n", n);
				fprintf(fp, "\n");
				break;
		case RET_QUAD:  fprintf(fp, "\tjmp ");
				endof(fp, NULL, 1);
				fprintf(fp, "\n");
				break;
		case PAR_QUAD:  
				if(l->fourth.code == true)  //string
				{
					fprintf(fp, "\tmov ax, offset %s\n", l->sec.q_union.name);
					fprintf(fp, "\tpush ax\n");
				}
				else if( l->sec.q_union.x->entryType == ENTRY_VARIABLE && l->sec.q_union.x->u.eVariable.type->kind == TYPE_ARRAY
					|| l->sec.q_union.x->entryType == ENTRY_PARAMETER && l->sec.q_union.x->u.eParameter.type->kind == TYPE_IARRAY
					|| l->third.q_union.pass == R || l->third.q_union.pass == RET)
				{
					fprintf(fp, ";Bef loadAddr\n");
					loadAddr(fp, "si", l->sec.q_union.x, 0);
					//fprintf(fp, ";Aft loadAddr\n");
					if(l->fourth.q_union.x != NULL)
					{

						load(fp, "ax", l->fourth.q_union.x, false, 0);
						fprintf(fp, "\tmov cx, %d\n", l->size == 1 ? 2:1);
						fprintf(fp, "\timul cx\n");
						fprintf(fp, "\tadd si,ax\n");
					}
					fprintf(fp, "\tpush si\n");
				}				
				else if(l->third.q_union.pass == V && l->size == true) {
					load(fp, "ax", l->sec.q_union.x, l->sec.code, 0);
					fprintf(fp, "\tpush ax\n");
				}
				else //if(l->third.q_union.pass == V)
				{
					load(fp, "al", l->sec.q_union.x, l->sec.code, 0);
					fprintf(fp, "\tsub sp,1\n\tmov si,sp\n");
					fprintf(fp, "\tmov byte ptr [si], al\n");
				} 											
				break;
		case JMP_QUAD:  fprintf(fp, "\tjmp ");
				label(fp, l->fourth.q_union.label, 1);
				fprintf(fp, "\n");
				break;		
		case ARR2T_QUAD:
				
				loadAddr(fp, "si", l->sec.q_union.x, 0);
				load(fp, "di", l->third.q_union.x, l->third.code, 0);
				// asm code to ensure index not out of limits
				if(l->sec.q_union.x->entryType != ENTRY_PARAMETER )
				{
					load(fp, "cx", l->sec.q_union.x->u.eVariable.type->size, true, 0);				
					fprintf(fp, "\tcmp cx,di\n");
					fprintf(fp, "\tjg ");label(fp, counter, 5);
						// asm code to print error msg
					fprintf(fp, "\tmov dx, offset msg1\n\tmov ah,9\n\tint 21h\n");
					fprintf(fp, "\tjmp ");endof(fp, NULL, 1);
					label(fp, counter, 4);
				}
				// asm code to ensure index not out of limits ends
				fprintf(fp, "\tadd si,di\n");
				if(l->size) fprintf(fp, "\tadd si,di\n");
				fprintf(fp, "\tmov %s,%s ptr [si]\n", l->size ? "ax":"al", l->size ? "word":"byte");
				if(l->size)
					store(fp, "ax", l->fourth.q_union.x, NULL);
				else
					store(fp, "al", l->fourth.q_union.x, NULL);
				break;
		case T2ARR_QUAD:
				load(fp, "ax", l->sec.q_union.x, l->sec.code, 0);				
				load(fp, "di", l->third.q_union.x, l->third.code, 0);
				loadAddr(fp, "si", l->fourth.q_union.x, 0);
				// asm code to ensure index not out of limits
				if(l->fourth.q_union.x->entryType != ENTRY_PARAMETER )
				{
					load(fp, "cx", l->fourth.q_union.x->u.eVariable.type->size, true, 0);				
					fprintf(fp, "\tcmp cx,di\n");
					fprintf(fp, "\tjg ");label(fp, counter, 5);
						// asm code to print error msg
					fprintf(fp, "\tmov dx, offset msg1\n\tmov ah,9\n\tint 21h\n");
					fprintf(fp, "\tjmp ");endof(fp, NULL, 1);
					label(fp, counter, 4);
				}
				// asm code to ensure index not out of limits ends				
				fprintf(fp, "\tadd si,di\n");
				if(l->size) fprintf(fp, "\tadd si,di\n");
				fprintf(fp, "\tmov %s ptr [si],%s\n", l->size ? "word":"byte", l->size ? "ax":"al");
				break;
				
		}
			
}

void push_FuncList(int Scope, int b_counter, char *func_name)
{
	Scope_FuncList *tmp = (Scope_FuncList *)malloc(sizeof(Scope_FuncList));
	tmp->Scope = Scope;
	tmp->Block_Counter = b_counter;
	tmp->name = (char *)malloc(strlen(func_name) + 1);
	strcpy(tmp->name, func_name);
	tmp->next = Queue;
	Queue = tmp;
}

void pop_FuncList(int Scope)
{	
	while((Queue != NULL) && (Queue->Scope == Scope ))
	{
		pop_one_FuncList();
	}
}

void pop_one_FuncList()
{	
	Scope_FuncList *tmp;
	if(Queue == NULL)
		fprintf(stderr, "error in pop_Funclist\n");
	else {
		tmp = Queue;
		Scope_FuncList *tmp;
		Queue = Queue->next;
		//free(tmp->name);
		//free(tmp);
	}
}
void print_FuncList()
{
	Scope_FuncList *tmp = Queue;
	while(tmp != NULL)
	{
		fprintf(stdout, "name:%s,  scope=%d,   b_c=%d\n", tmp->name, tmp->Scope, tmp->Block_Counter);
		tmp = tmp->next;
	}
}
int find_FuncList(char *func_name)
{
	//print_FuncList();
	int i=0;
	Scope_FuncList *tmp = Queue;
	while (tmp != NULL)
	{
		if(strcmp(func_name, tmp->name))
			tmp = tmp->next;
		else {
			return tmp->Block_Counter;
		}
	}
	fprintf(stderr, "error in find_FuncList\n");
	exit(1);
}


Quad_list *NextQuad()
{
	return(bottom2);
}

Quad_list *MakeList(Quad_list *a)
{
	if(a == NULL) {
		fprintf(stderr, "First use genquad, and then Makelist");
		return 0;
	}	
	return a;
}

Quad_list *MergeList(Quad_list *l1, Quad_list *l2)
{
	Quad_list *tmp;
	tmp = l1; 
	if( l1 == NULL)
		fprintf(stdout, "Problem\n");
	while(l1->list_next != NULL)	
		l1 = l1->list_next;
	l1->list_next = l2;
	return(tmp);
}

	
void BackPatch(Quad_list *a, int label)
{
	// rememeber to use one less than the current label_c
	// because genquad(label_c ++,...) has been used first	
	if (a == NULL) {
		return ;
	}
	else 
	{	
		a->fourth.q_union.label = label;	
		while(a->list_next != NULL)
		{	
			
			a = a->list_next;
			a->fourth.q_union.label = label ;		
		}
	}	
}


void initAsmFile(FILE *fp)
{
	//fprintf(fp, "dseg segment\ninclude data.asm\ndseg ends\n\n\n");
	fprintf(fp, "xseg segment public \'code\'\n");
	fprintf(fp, "\tassume cs:xseg, ds:xseg, ss:xseg\n");	
	fprintf(fp, "\torg 100h\n");
	fprintf(fp, "main    proc near\n");
	//fprintf(fp, "\tmov ax,xseg\n\tmov ds,ax\n\tmov ss,ax\n");
	fprintf(fp, "\tcall near ptr _main_1\n");
	fprintf(fp, "\tmov ax,4c00h\n\tint 21h\nmain    endp\n");
}
void initDataFile(FILE *fp)
{
	fprintf(fp, "msg1\tdb \'Array index out of limits.$\'\n");
}

void endAsmFile(FILE *fp)
{
	fprintf(fp, "\tinclude data.asm\n");
	fprintf(fp, "xseg ends\n\tend main\n");
}

char *String2asm(FILE *fp, char *s)
{	
	int i ;
	bool frstChar = true;
	char *tmp;	
	fprintf(fp, "@str%d", ++str_counter);	
	tmp = (char *)malloc(5 + strlen(myitoa(str_counter, NULL, 10)));
	sprintf(tmp, "@str%d", str_counter);
	if(strlen(s) == 3)
		fprintf(fp, "\tdb \'%c'\n", s[1]);
	else
		for(i = 1; i < strlen(s) - 1; i++)
		{
			if(s[i] == '\\')
				switch(s[++i])
					{
					case 'n':
						if(!frstChar)
							fprintf(fp, "\'\n");
						fprintf(fp, "\tdb %d\n", 10);
						frstChar = true;
						break;
					case 't':
						if(!frstChar)
							fprintf(fp, "\'\n");
						fprintf(fp, "\tdb %d\n", 9);
						frstChar = true;
						break;
					case '\"':
						if(!frstChar)
							fprintf(fp, "\'\n");
						fprintf(fp, "\tdb %d\n", 34);
						frstChar = true;
						break;
					case '\'':
						if(!frstChar)
							fprintf(fp, "\'\n");
						fprintf(fp, "\tdb %d\n", 96);
						frstChar = true;
						break;
					case '0':
						if(!frstChar)
							fprintf(fp, "\'\n");
						fprintf(fp, "\tdb %d\n", 0);
						i = strlen(s) + 1;
						break;
					case '\\':
						if(!frstChar)
							fprintf(fp, "\'\n");
						fprintf(fp, "\tdb %d\n", 92);
						frstChar = true;
						break;				
					default:
						if(!frstChar)
							fprintf(fp, "\'\n");
						fprintf(fp, "\tdb %d\n", s[i]);
						frstChar = true;
						break;
					}				
			else {	
				if(frstChar) {
					frstChar = false;
					fprintf(fp, "\tdb \'%c", s[i]);
				}
				else if( i == strlen(s)-2 ) {
					fprintf(fp, "%c\'\n", s[i]);
					//fprintf(fp, "\tdb 0\n");
				}			
				else {
					fprintf(fp, "%c", s[i]);;
				}
			}		
			
		}
	fprintf(fp, "\tdb 0\n");
	return tmp;
}

char * myitoa(int x, char * dummy, int base)
{
   static char buffer[20];

   sprintf(buffer, "%d", x);
   return buffer;
}
