/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 *    	mpapakyr@softlab.ece.ntua.gr   *
 *   							       *
 *    		tsokos@softlab.ece.ntua.gr     *
 *  							       *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  		   		       *
 *  		   	       *
 *  							       *
 *  	: `   Calvin`	       *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 							       *
 *  File Name: 		quad2asm.h			       *
 *  Version: 		1.0 Final 			       *
 *  Description:        C header file for quad2asm.c	       *
 *  Date:    		23/10/2003 1:11		       *
 *  							       *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



/* ------------------------------------------------------------
   ----------     .-------
   ------------------------------------------------------------ */
   
typedef enum 	{ 
		PLUS_QUAD,MINUS_QUAD,MULT_QUAD,DIV_QUAD,MOD_QUAD,
		EQ_QUAD,NE_QUAD,GT_QUAD,GE_QUAD,LT_QUAD,LE_QUAD,
		ASSIGN_QUAD,CALL_QUAD,PAR_QUAD,JMP_QUAD,RET_QUAD,
		UNIT_QUAD,ENDU_QUAD,ARRAY_QUAD,RETV_QUAD,IFB_QUAD,
		ARR2T_QUAD, T2ARR_QUAD
	     	} Quad_Type;
char *quad_tag[23];
char *pass_tag[3];

typedef union {
	SymbolEntry *x;
	char *name;
} b_enum_type;

typedef struct b_struct {
	b_enum_type q_union;
	bool code ;
} b;


typedef enum {
		V,R,RET	
	} pass_enum;

typedef union {
	SymbolEntry *x;		
	pass_enum pass;	 	
	bool code;
} c_enum_type;	

typedef struct c_struct {
	c_enum_type q_union;
	bool code ;	
	int size;
} c;

typedef union {
	SymbolEntry *x;		
	int label;	   
	char *name;
} d_enum_type;	

typedef struct d_struct {
	d_enum_type q_union;
	bool code ;
	int label;
} d;
	
	      
typedef struct Quad_list_tag Quad_list;

struct Quad_list_tag {
	int label;
	Quad_Type type;
	b sec;
	c third;
	d fourth;
	bool size;
	Quad_list *next, *prior, *list_next;
};

Quad_list *head2, *bottom2, *head3;

/* ------------------------------------------------------------
   ----------      ----------
   ----------     . ------------
   ------------------------------------------------------------ */
typedef struct Scope_FuncList_tag Scope_FuncList;

struct Scope_FuncList_tag {
	int Scope;
	int Block_Counter;
	char * name;
	Scope_FuncList *next;
} ;

void push_FuncList(int, int , char *);
void  pop_FuncList(int);
void  pop_one_FuncList();
void print_FuncList();
int find_FuncList(char *);

Scope_FuncList *Queue = NULL;



/* ------------------------------------------------------------
   ----------       ----
   -------------------   . ----------------------
   ------------------------------------------------------------ */


void BackPatch(Quad_list *, int );
void endof(FILE *, SymbolEntry *, int );
void getAR(FILE *, SymbolEntry *);
void label(FILE *, int , int );
void load(FILE *,char *,SymbolEntry *, bool, int);
void loadAddr(FILE *, char *, SymbolEntry *, int);
void name(FILE *, SymbolEntry *, int );
void call_name(FILE *, SymbolEntry *, int );
void store(FILE *, char *, SymbolEntry *, SymbolEntry *);
void updateAL(FILE *, SymbolEntry *);
char *String2asm(FILE *, char *);

Quad_list *NextQuad();
Quad_list *MakeList(Quad_list *);
Quad_list *MergeList(Quad_list *, Quad_list *);

char *endof_str;
int block_counter = 2;
int str_counter = 0;
int counter = 1;


/* ------------------------------------------------------------
   ----------       -----
   -----------------    . ------------------
   ------------------------------------------------------------ */


int genquad(int , Quad_Type , b , c , d ,bool);
void ScopeQuads2file(FILE *, Quad_list **);


void quad2asm(FILE *, Quad_list *);
void ScopeQuads2asm(FILE *, Quad_list **);

void initAsmFile(FILE *);
void initDataFile(FILE *);
void endAsmFile(FILE *);

void all_quads2asm(FILE *, Quad_list *);
int print_one_quad(FILE *, Quad_list *);
void printquad(FILE *, Quad_list *);
FILE * init_file();
void init_tags();
bool first_asm = true, first_quad = true;



char * myitoa(int , char * , int );







